<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * administrator/components/com_jmylife/helpers/comment.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 * @since     1.0.14
 */
// no direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');
if (!class_exists('JmylifeConfiguration')) {
	$configfile = JPATH_ROOT.DS.'components'.DS.'com_jmylife'.DS.'libraries'.DS.'configuration.php';
	if( JFile::exists( $configfile ) ) require_once( $configfile );
}
JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');

class JmylifeCommentHelper
{
	private static $_instance;
	var $cfg;
	var $html;
	var $itemid;
	var $_string;
	var $url;

	function __construct() {
		$this->cfg = JmylifeConfiguration::getInstance();
		$this->html = JmylifeHtmlHelper::getInstance();
		$this->_string = JmylifeStringHelper::getInstance();
	}

	function getInstance() {
		if (!self::$_instance) {
			self::$_instance = new JmylifeCommentHelper();
		}
		return self::$_instance;
	}

	/**
	 * buildQuery
	 * @param   int
	 * @param   int
	 * @return  string
	 */
	function buildQuery($id, $published=1, $latest=false) {
		$blankquery = 'SELECT 1';
		$query = $blankquery;
		// build query based on comment engine
		// PLEASE NOTE: this query should ONLY be used for comment balloons,
		// and NOT for anything else!!!
		// since 1.0.13
		// Ignoring my previous note ;)
		// using this in link layout header
				// var init
				$join = 'LEFT JOIN `#__jmylife_comments_warnings` AS w'
				      . ' ON ( c.`id` = w.`cid` ) '
				      . 'LEFT JOIN `#__users` AS u'
				      . ' ON ( c.`author_id` = u.`id` ) '
				      ;
				$group = ' GROUP BY c.`id` ';
				$fields = array('c.*', 'COUNT( w.`ip` ) AS warninglevel', 'u.`username`');
				$wheres = array('c.`sid`='.intval($id));
				if ($published >= 0) {
					$wheres[] = 'c.`published` = '.intval($published);
				}

				// build query
				$query = 'SELECT '
				       . implode(', ', $fields).' '
				       . 'FROM `#__jmylife_comments` AS c '
				       . $join
				       . 'WHERE ( '.implode(' ) AND ( ', $wheres).' ) '
				       . $group
							 . 'ORDER BY c.`id` '.($latest ? 'DESC' : 'ASC')
				       ;
		return $query;
	}

	/**
	 * buildQueryById
	 * @param   int
	 * @return  string
	 *
	 * PLEASE NOTE this only works on Core comments for now
	 */
	function buildQueryById($id) {
		$join = 'LEFT JOIN `#__jmylife_comments_warnings` AS w'
		      . ' ON ( c.`id` = w.`cid` ) '
		      . 'LEFT JOIN `#__users` AS u'
		      . ' ON ( c.`author_id` = u.`id` ) '
		;
		$group = ' GROUP BY c.`id`, c.`sid` ';
		$fields = array(
			'c.*',
			'COUNT( w.`ip` ) AS warninglevel',
			'u.`username`'
		);
		$wheres = array( 'c.`id`='.intval( $id ) );
		// build query
		$query = 'SELECT '
		       . implode( ', ', $fields ).' '
		       . 'FROM `#__jmylife_comments` AS c '
		       . $join
		       . 'WHERE ( '.implode( ' ) AND ( ', $wheres ).' ) '
		       . $group
		       . 'LIMIT 1'
		;
		return $query;
	}

	/**
	 * prepare
	 * @param   object
	 * @param   string
	 * @return  object
	 */
	function prepare($object, $view='') {
		@$object->message = nl2br($this->html->clean(@$object->message));
		@$object->author  = $this->html->clean(@$object->author);
		if ($this->cfg->getInt('comment_username')) {
			@$object->author = $this->html->clean(@$object->username);
		}
		if ($this->cfg->getInt('break_long_words')) {
			@$object->message = $this->_string->breakLongWords(@$object->message);
			@$object->author  = $this->_string->breakLongWords(@$object->author);
		}
		return $object;
	}

	/**
	 * prepareList
	 * @param   array
	 * @param   string
	 * @return  array
	 */
	function prepareList($list, $view='') {
		for ($i=0; $i<count($list); $i++) {
			@$list[$i] = $this->prepare(@$list[$i], $view);
		}
		return $list;
	}

}
